#!/usr/bin/perl

# STDIN: graphs in the format of Miklos's applet
# STDOUT: table of admitted polymorphisms

use strict;
use Switch;
use Sys::Hostname;

###### CONSTANTS!!!
my $dir = "/srv/groot/stanovsk/ar/gpoly";
#my $dir = "/usr/users/stanovsk/gpoly";
#my $dir = "/home/guest/gpoly";
my $time_limit = 60;
my $format = "%06d ";    # pocet cifer u $graph_id

open(LOG,">>$dir/gp$$.log");
open(ERR,">>$dir/gp$$.err");

# aktualni graf
my $graph_id;
my $graph_size;
my @graph;			# pole stringu, $graph[i] = i-ta radka tabulky bez mezer

# polymorfismy (hash indexovany nazvy soubory.poly)
my %poly_symbols;		# string popisujici symboly+arity v polymorfismu [format: napr. "t2s3u2" znamena t arity 2, s arity 3, u arity 2]
#my %poly_mace;			# string popisujici polymorfismus ve formatu Mace4
my %poly_paradox;		# string popisujici polymorfismus ve formatu Paradox
my %poly_admit;			# status pro aktualni graf

################# zpracuj
# does the graph have the ARG polymorphism?
sub zpracuj {
 my $p = shift(@_);
 my $cputime;
 my $i;

###MACE
# my $vysledek_mace=3;
 
# vytvor vstupni soubor 
# open(IN,">$dir/gp$$.in");
# print IN "assign(domain_size, $graph_size). assign(iterate_up_to, $graph_size).\nformulas(assumptions).\n";

#	- podminky na polymorfismus
# print IN "$poly_mace{$p}";
 
#	- zachovani relace
# for(my $i=0;$i<length $poly_symbols{$p};$i+=2) 
#  {
#   my $symbol=substr($poly_symbols{$p},$i,1);
#   my $arity=substr($poly_symbols{$p},$i+1,1);
#   switch ($arity) 
#    {
#     case 2 { print IN "(R(v0,v1) & R(v2,v3)) -> R($symbol(v0,v2),$symbol(v1,v3)).\n" }
#     case 3 { print IN "(R(v0,v1) & R(v2,v3) & R(v4,v5)) -> R($symbol(v0,v2,v4),$symbol(v1,v3,v5)).\n" }
#     case 4 { print IN "(R(v0,v1) & R(v2,v3) & R(v4,v5) & R(v6,v7)) -> R($symbol(v0,v2,v4,v6),$symbol(v1,v3,v5,v7)).\n" }
#     case 5 { print IN "(R(v0,v1) & R(v2,v3) & R(v4,v5) & R(v6,v7) & R(v8,v9)) -> R($symbol(v0,v2,v4,v6,v8),$symbol(v1,v3,v5,v7,v9)).\n" }
#     else { die "Only arities <=5 supported."; }
#    };
#  };
  
#	- tabulka grafu
# for(my $i=0;$i<$graph_size;$i++)
#  {
#	for(my $j=0;$j<$graph_size;$j++) 
#	 { my $t=substr($graph[$i],$j,1); if ($t eq "1") { print IN "R($i,$j).\n"; } else { print IN "-R($i,$j).\n"; }; };
#  };
#	
# print IN "end_of_list.\n";
# close IN;

# spust dokazovac
# $cputime=time;
# `mace4 -t $time_limit < $dir/gp$$.in >& $dir/gp$$.out`;
# $cputime-=time;

# vyhodnot vysledek
# my $cputime1="";    #smazat?
# open(OUT,"<$dir/gp$$.out");
# while (<OUT>) 
#  {
#   if (/exhausted/) { $vysledek_mace=0; };
#   if (/MODEL/) { $vysledek_mace=1; };
#   if (/max_sec/) { $vysledek_mace=2; };
#   if (/System_CPU/) { $cputime1=$_; };   #smazat?
#  };
# close OUT;
  
### ZATIM: logfile>dokazovac+uloha(graf_id,poly)+vysledek+cas
# print LOG "Mace4 $graph_id $p $vysledek_mace $cputime $cputime1";

# jestlize timeout nebo jina chyba => errfile>dokazovac+uloha(graf_id,poly)+vysledek
# if ($vysledek_mace==2) { print ERR "Mace4 $graph_id $p TIMEOUT\n"; };
# if ($vysledek_mace==3) { die "Mace4 $graph_id $p ERROR, see gp$$.{in,out}\n"; };  ### ZATIM: die, NAOSTRO print ERR


###PARADOX
 my $vysledek_paradox=3;
 
# vytvor vstupni soubor 
 open(IN,">$dir/gp$$.in");

#	- podminky na polymorfismus
 print IN "$poly_paradox{$p}";

#	- zachovani relace
 for(my $i=0;$i<length $poly_symbols{$p};$i+=2) 
  {
   my $symbol=substr($poly_symbols{$p},$i,1);
   my $arity=substr($poly_symbols{$p},$i+1,1);
   switch ($arity) 
    {
     case 2 { print IN "cnf(preserves,axiom,( ~ gr(X0,X1) | ~ gr(X2,X3) | gr($symbol(X0,X2),$symbol(X1,X3)) )).\n" }
     case 3 { print IN "cnf(preserves,axiom,( ~ gr(X0,X1) | ~ gr(X2,X3) | ~ gr(X4,X5) | gr($symbol(X0,X2,X4),$symbol(X1,X3,X5)) )).\n" }
     case 4 { print IN "cnf(preserves,axiom,( ~ gr(X0,X1) | ~ gr(X2,X3) | ~ gr(X4,X5) | ~ gr(X6,X7) | gr($symbol(X0,X2,X4,X6),$symbol(X1,X3,X5,X7)) )).\n" }
     case 5 { print IN "cnf(preserves,axiom,( ~ gr(X0,X1) | ~ gr(X2,X3) | ~ gr(X4,X5) | ~ gr(X6,X7) | ~ gr(X8,X9) | gr($symbol(X0,X2,X4,X6,X8),$symbol(X1,X3,X5,X7,X9)) )).\n" }
     else { die "Only arities <=5 supported."; }
    };
  };

#	- tabulka grafu
 for(my $i=0;$i<$graph_size;$i++)
  {
	for(my $j=0;$j<$graph_size;$j++) 
	 { my $t=substr($graph[$i],$j,1); if ($t eq "1") { print IN "cnf(graph,axiom,gr(n$i,n$j)).\n"; } else { print IN "cnf(graph,axiom,~gr(n$i,n$j)).\n"; }; };
  };

# constants for elements: all distinct, nothing more
 for(my $i=0;$i<$graph_size;$i++) { for(my $j=$i+1;$j<$graph_size;$j++) { print IN "cnf(elems,axiom,n$i != n$j).\n"; };};
 my $i; print IN "cnf(elems,axiom,("; for($i=0;$i<$graph_size-1;$i++) { print IN " X=n$i |"; }; print IN " X=n$i )).\n";

 close IN;

# spust dokazovac
# `$dir/paradoxwrapper $dir/gp$$.in > $dir/gp$$.out`;
 $cputime=time;
 `paradox --time $time_limit $dir/gp$$.in > $dir/gp$$.out`;
 $cputime-=time;

# vyhodnot vysledek
 open(OUT,"<$dir/gp$$.out");
 while (<OUT>) 
  {
   if (/Unsatisfiable/) { $vysledek_paradox=0; };
   if (/Satisfiable/) { $vysledek_paradox=1; };
   if (/Timeout/) { $vysledek_paradox=2; };
#   if (/???????/) { $cputime=$_; };   # zde by se hodil cas, ale on ho Paradox nevraci...
  };
 close OUT;

### ZATIM: logfile>dokazovac+uloha(graf_id,poly)+vysledek+cas
 print LOG "Paradox $graph_id $p $vysledek_paradox $cputime\n";

# jestlize timeout nebo jina chyba => errfile>dokazovac+uloha(graf_id,poly)+vysledek
 if ($vysledek_paradox==2) {  print ERR "Paradox $graph_id $p TIMEOUT\n"; }
 if ($vysledek_paradox==3) { print ERR "Paradox $graph_id $p ERROR\n"; };

### ODPOVED

### ZATIM:
# if ( ($vysledek_paradox==1 && $vysledek_mace==0) || ($vysledek_paradox==0 && $vysledek_mace==1) ) { die "$graph_id $p INCONSISTENT ANSWERS: Mace4 $vysledek_mace Paradox $vysledek_paradox"; };
# if ($vysledek_paradox>1 && $vysledek_mace<2) { print ERR "Mace4 OK, Paradox TIMEOUT!\n"; return $vysledek_mace; };
# if ($vysledek_paradox<2 && $vysledek_mace>1) { print ERR "Paradox OK, Mace4 TIMEOUT!\n"; return $vysledek_paradox; };

 return $vysledek_paradox;

}
################# end of zpracuj


################# MAIN

my $str;
my $i;

$i=gmtime(time);
$str = hostname;
print "*GP* $$ on $str at $i GMT\n";

### 1. nacti %poly_*
`ls $dir/*.poly >$dir/gp$$.tmp`;
open(TMP,"<$dir/gp$$.tmp");
while (<TMP>) 
 {
  $str=$_;
  $str =~ s/\/([^\/]*)\.//;
  my $id=$1;
  $poly_symbols{$id}="";
#  $poly_mace{$id}="";
  $poly_paradox{$id}="";
  $poly_admit{$id}=-1;

  my $ind="head";
 
  open(POLY,"<$dir/$id.poly");
  while (<POLY>) 
   { 
    #header
    if ($ind eq "head") 
     {
 	  my $s=$_;
          if (/\S/) 
	   {
	     $s =~ /(.*)\ (\d)/;
	     $poly_symbols{$id}.="$1$2";
	   }
	   else { $ind="rest";};
     }
    #the rest
    else
     { 
	  my $s=$_;
#	  $poly_mace{$id}.=$s; 
	  $s=~/(.*)\./; 
	  $s=$1; 
	  $s =~ s/x/X/g;$s =~ s/y/Y/g;$s =~ s/z/Z/g; 
	  if ($s=~/\S/) { $poly_paradox{$id}.="cnf(poly$id,axiom, $s ).\n";};
     };
   };
  close POLY;
  print LOG "POLY $id OF TYPE $poly_symbols{$id}\n$poly_paradox{$id}\n";
 };
close TMP;
`rm $dir/gp$$.tmp`;
print LOG "POLYMORPHISM READING FINISHED\n";

foreach(keys %poly_admit) { print "$_ "; }; print "\n";


### 2. while not EOF do 
while (<STDIN>) {


### 3. nacti dalsi graf do pameti

 #<!-- isomorphism type #1 -->
 #<algebra size="4">
 #    <relation arity="2" size="4">
 #        0 0 0 0
 #        0 0 0 0
 #        0 0 0 0
 #        0 0 0 0
 #    </relation>
 #</algebra>
 
 $str=$_;
 $str =~ /#(\d*)/;
 $graph_id=$1;

 $str=<STDIN>;
 $str =~ /"(.*)"/;
 $graph_size=$1;
 
 $str=<STDIN>;
 for($i=0;$i<$graph_size;$i++)
  {
    $str=<STDIN>;
    $str =~ s/\s//g;
    $graph[$i] = $str;
  };
 $str=<STDIN>;$str=<STDIN>;$str=<STDIN>;

 print LOG "\nGraph $graph_id read.\n";


### 4. zpracuj aktualni graf v pameti
 foreach(keys %poly_admit) { $poly_admit{$_}=0; };

 $poly_admit{'arith'}=zpracuj("arith");
 if ($poly_admit{'arith'}==1) { $poly_admit{'nu3'}=1;$poly_admit{'malcev'}=1;};

 if ($poly_admit{'malcev'}!=1) { $poly_admit{'malcev'}=zpracuj("malcev"); };
 if ($poly_admit{'malcev'}==1) { $poly_admit{'edge4'}=1; }; 

 if ($poly_admit{'nu3'}!=1) { $poly_admit{'nu3'}=zpracuj("nu3"); };
 if ($poly_admit{'nu3'}==1) { $poly_admit{'nu4'}=1;$poly_admit{'edge4'}=1; }; 

 if ($poly_admit{'nu4'}!=1) { $poly_admit{'nu4'}=zpracuj("nu4"); };
 if ($poly_admit{'nu4'}==1) { $poly_admit{'nu5'}=1;$poly_admit{'edge5'}=1; }; 

 if ($poly_admit{'nu5'}!=1) { $poly_admit{'nu5'}=zpracuj("nu5"); };
 if ($poly_admit{'nu5'}==1) { $poly_admit{'omit12'}=1; }; 

 if ($poly_admit{'edge4'}!=1) { $poly_admit{'edge4'}=zpracuj("edge4"); };
 if ($poly_admit{'edge4'}==1) { $poly_admit{'edge5'}=1; }; 

 if ($poly_admit{'edge5'}!=1) { $poly_admit{'edge5'}=zpracuj("edge5"); };
 if ($poly_admit{'edge5'}==1) { $poly_admit{'siggers'}=1; }; 

 $poly_admit{'sml'}=zpracuj("sml");
 if ($poly_admit{'sml'}==1) { $poly_admit{'2sml'}=1;$poly_admit{'ts4'}=1; }; 
 
 if ($poly_admit{'2sml'}!=1) { $poly_admit{'2sml'}=zpracuj("2sml"); };
 if ($poly_admit{'2sml'}==1) { $poly_admit{'wnu2'}=1;$poly_admit{'omit12'}=1; };
 
 if ($poly_admit{'ts4'}!=1) { $poly_admit{'ts4'}=zpracuj("ts4"); };
 if ($poly_admit{'ts4'}==1) { $poly_admit{'ts3'}=1; }; 

 if ($poly_admit{'ts3'}!=1) { $poly_admit{'ts3'}=zpracuj("ts3"); };
 if ($poly_admit{'ts3'}==1) { $poly_admit{'wnu2'}=1;$poly_admit{'wnu3'}=1;  }; 

 if ($poly_admit{'omit12'}!=1) { $poly_admit{'omit12'}=zpracuj("omit12"); };
 if ($poly_admit{'omit12'}==1) { $poly_admit{'wnu3'}=1; $poly_admit{'wnu4'}=1; $poly_admit{'wnu5'}=1; }; 

 if ($poly_admit{'wnu2'}!=1) { $poly_admit{'wnu2'}=zpracuj("wnu2"); };
 if ($poly_admit{'wnu2'}==1) { $poly_admit{'wnu4'}=1; }; 

 if ($poly_admit{'wnu3'}!=1) { $poly_admit{'wnu3'}=zpracuj("wnu3"); };
 if ($poly_admit{'wnu3'}==1) { $poly_admit{'siggers'}=1; }; 

 if ($poly_admit{'wnu4'}!=1) { $poly_admit{'wnu4'}=zpracuj("wnu4"); };
 if ($poly_admit{'wnu4'}==1) { $poly_admit{'siggers'}=1; }; 
 
 if ($poly_admit{'wnu5'}!=1) { $poly_admit{'wnu5'}=zpracuj("wnu5"); };
 if ($poly_admit{'wnu5'}==1) { $poly_admit{'siggers'}=1; }; 

 if ($poly_admit{'siggers'}!=1) { $poly_admit{'siggers'}=zpracuj("siggers"); };
# if ($poly_admit{'siggers2'}!=$poly_admit{'siggers3'}) { print ERR "SIGGERS CLASH ON $graph_id: Siggers2=$poly_admit{'siggers2'} Siggers3=$poly_admit{'siggers3'}\n"; };


### 5. stdout>radek vysledku, logfile>"graf zpracovan"
# print "$graph_id ";
 printf($format, $graph_id);
 for(my $i=0;$i<$graph_size-1;$i++) { print "$graph[$i]|"; }; print "$graph[$graph_size-1] ";
 foreach(keys %poly_admit) { print "$poly_admit{$_}"; };
 print "\n";
 print LOG "Graph $graph_id finished.\n";

}; ### konec cyklu 2.

close LOG;
close ERR;
`rm $dir/gp$$.in $dir/gp$$.out`;

################## KONEC

#MAIN:
#1. nacti *.poly do vnitrni databaze ve formatu .mace, .paradox
#2. while not EOF do 
#3.		nacti dalsi graf do pameti
#4.		zpracuj aktualni graf v pameti
#5.		stdout>radek vysledku, logfile>"graf zpracovan"
#
#ad 4.:
#podle daneho schematu zavislosti postupne poustej zpracuj(graf,poly_n)
#
#sub zpracuj_DOKAZOVAC(graf,poly):    (verze mace, paradox)
# vytvor vstupni soubor
#	- podminky na polymorfismus
#	- tabulka grafu
#	- zachovani relace
# spust dokazovac
#    - prozatim: oba dokazovace
# vyhodnot vysledek
#	- prozatim: logfile>dokazovac+uloha(graf_id,poly)+vysledek+cas
# jestlize timeout nebo jina chyba => errfile>dokazovac+uloha(graf_id,poly)+vysledek
# odpovez 0=Unsat.,1=Satisfiable,2=Timeout,3=jina chyba

